
/* Esercizio 2 di Esercizidel30-5-17
 Stiamo utilizzando code di tipo {\tt MuQueueADT} all'interno di un sistema in grado 
 di raccogliere anche il tempo di arrivo nella coda.
 Il tempo sia espresso da una tripla {\tt h:m:s} indicante ora, minuti e secondi.
 I valori da accodare sono oggetti di un tipo dato {\tt Item}.
 Il nostro compito \`e scrivere un codice per calcolare il tempo medio di interarrivo degli
 items presenti nella coda associata alla variabile {\em theQueue}. Il valore calcolato deve 
 essere assegnato ad una variabile {\em interTime}.
 (a) Completare le assunzioni, in particolare si dica chi siano:\\
 \spz - il tipo della variabile interTime\\
 \spz - il tipo degli oggetti effettivamente contenuti in theQueue.\\
 (b) Scrivere un codice adatto alle assunzioni fatte.\\

 */

import java.util.*;
import java.lang.*;

/* (a) */
class invalidArgException extends Exception{
    public string method;
    invadidArgException(String g){
        method = g;
    }
}

class Time{//astratta
    private int h; //in [0..23]
    private int m; //in [0..59]
    private int s; //in [0..59]
    public Time(int h, int m, int s){...}
    public int hour(){...}
    ...
    public boolean LE(Time y){//this precede o uguaglia y
        ...
    }
    public Time subtractFrom(Time y) throws invalidArgException{
                        //y-this se this precede y, altrimenti...
        ...
    }
    public Time addTo(Time y){//this+y
        ...
    }
}

class TimedItem{//concreta (meglio astratta?)
    public Item elem;
    public Time inTime;
    public TimedItem(Item e, Time in){...}
}

/* 1) interTime ha tipo Time;
   2) theQueue contiene oggetti di tipo TimedItem
 */

/* (b) */
class Main{
    public static void main(String[] args) throws invalidArgException{
        ...//altro codice del sistema
        MuQueueADTX<TimedItem> theQueue = null;//theQueue \e` introdotta qui
        ...//altro codice
        Time interTime = new Time(0,0,0);//interTime \e` introdotto qui
        ...//altro codice del sistema
        //il nostro codice inizia qui
        MuQueueADTX<TimedItem> mycopy = theQueue.clone();
        while (mycopy.size() > 1) {
            TimedItem first = mycopy.get();
            mycopy.remove();
            Time Tfirst = first.inTime;
            Time Tnext = mycopy.get().inTime;
            if (!Tfirst.LE(Tnext)) break;
            interTime = interTime.addTo(Tfirst.subtractFrom(Tnext));
        }
    }
}

 
